package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static String _extroot = "";
public static String  _activity_create(boolean _firsttime) throws Exception{
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 27;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(67108864);
 BA.debugLineNum = 31;BA.debugLine="ExtRoot = GetExtRoot";
Debug.ShouldStop(1073741824);
mostCurrent._extroot = _getextroot();
 BA.debugLineNum = 32;BA.debugLine="Log(\" \")";
Debug.ShouldStop(-2147483648);
anywheresoftware.b4a.keywords.Common.Log(" ");
 BA.debugLineNum = 33;BA.debugLine="Log(\" \")";
Debug.ShouldStop(1);
anywheresoftware.b4a.keywords.Common.Log(" ");
 BA.debugLineNum = 34;BA.debugLine="Log(\"Ext Root directory = \" & ExtRoot)";
Debug.ShouldStop(2);
anywheresoftware.b4a.keywords.Common.Log("Ext Root directory = "+mostCurrent._extroot);
 BA.debugLineNum = 35;BA.debugLine="Log(\" \")";
Debug.ShouldStop(4);
anywheresoftware.b4a.keywords.Common.Log(" ");
 BA.debugLineNum = 36;BA.debugLine="Activity.Finish";
Debug.ShouldStop(8);
mostCurrent._activity.Finish();
 BA.debugLineNum = 37;BA.debugLine="End Sub";
Debug.ShouldStop(16);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 43;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(1024);
 BA.debugLineNum = 45;BA.debugLine="End Sub";
Debug.ShouldStop(4096);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 39;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(64);
 BA.debugLineNum = 41;BA.debugLine="End Sub";
Debug.ShouldStop(256);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _getextroot() throws Exception{
		Debug.PushSubsStack("GetExtRoot (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
boolean _rslt = false;
int _i = 0;
String _temproot = "";
String _startdir = "";
String _testdir1 = "";
String _testdir2 = "";
String _t1 = "";
String _t2 = "";
anywheresoftware.b4a.keywords.StringBuilderWrapper _sb = null;
int _slashcnt = 0;
 BA.debugLineNum = 47;BA.debugLine="Sub GetExtRoot As String";
Debug.ShouldStop(16384);
 BA.debugLineNum = 49;BA.debugLine="Dim Rslt As Boolean 'Result of each location determination attempt.  See code.";
Debug.ShouldStop(65536);
_rslt = false;Debug.locals.put("Rslt", _rslt);
 BA.debugLineNum = 50;BA.debugLine="Dim I As Int 'Loop counter";
Debug.ShouldStop(131072);
_i = 0;Debug.locals.put("I", _i);
 BA.debugLineNum = 51;BA.debugLine="Dim TempRoot, StartDir, TestDir1, TestDir2, T1, T2 As String 'Holds temporary directories.";
Debug.ShouldStop(262144);
_temproot = "";Debug.locals.put("TempRoot", _temproot);
_startdir = "";Debug.locals.put("StartDir", _startdir);
_testdir1 = "";Debug.locals.put("TestDir1", _testdir1);
_testdir2 = "";Debug.locals.put("TestDir2", _testdir2);
_t1 = "";Debug.locals.put("T1", _t1);
_t2 = "";Debug.locals.put("T2", _t2);
 BA.debugLineNum = 52;BA.debugLine="Dim SB As StringBuilder 'Used to build the string that will hold the actual external SD card root directory.";
Debug.ShouldStop(524288);
_sb = new anywheresoftware.b4a.keywords.StringBuilderWrapper();Debug.locals.put("SB", _sb);
 BA.debugLineNum = 53;BA.debugLine="Dim SlashCnt As Int 'Holds the count of the \"/\" in processing TempRoot.";
Debug.ShouldStop(1048576);
_slashcnt = 0;Debug.locals.put("SlashCnt", _slashcnt);
 BA.debugLineNum = 55;BA.debugLine="TempRoot = \"Root not found.\"";
Debug.ShouldStop(4194304);
_temproot = "Root not found.";Debug.locals.put("TempRoot", _temproot);
 BA.debugLineNum = 56;BA.debugLine="SlashCnt = 0";
Debug.ShouldStop(8388608);
_slashcnt = (int)(0);Debug.locals.put("SlashCnt", _slashcnt);
 BA.debugLineNum = 57;BA.debugLine="SB.Initialize";
Debug.ShouldStop(16777216);
_sb.Initialize();
 BA.debugLineNum = 62;BA.debugLine="Log(\" \")";
Debug.ShouldStop(536870912);
anywheresoftware.b4a.keywords.Common.Log(" ");
 BA.debugLineNum = 63;BA.debugLine="Log(\" \")";
Debug.ShouldStop(1073741824);
anywheresoftware.b4a.keywords.Common.Log(" ");
 BA.debugLineNum = 64;BA.debugLine="Log(\"Show the paths returned by the methods shown:\")";
Debug.ShouldStop(-2147483648);
anywheresoftware.b4a.keywords.Common.Log("Show the paths returned by the methods shown:");
 BA.debugLineNum = 65;BA.debugLine="Log(\" \")";
Debug.ShouldStop(1);
anywheresoftware.b4a.keywords.Common.Log(" ");
 BA.debugLineNum = 66;BA.debugLine="Log(\"DirAssets = \" & File.DirAssets)";
Debug.ShouldStop(2);
anywheresoftware.b4a.keywords.Common.Log("DirAssets = "+anywheresoftware.b4a.keywords.Common.File.getDirAssets());
 BA.debugLineNum = 67;BA.debugLine="Log(\"DirInternal = \" & File.DirInternal)";
Debug.ShouldStop(4);
anywheresoftware.b4a.keywords.Common.Log("DirInternal = "+anywheresoftware.b4a.keywords.Common.File.getDirInternal());
 BA.debugLineNum = 68;BA.debugLine="Log(\"DirInternalCache = \" & File.DirInternalCache)";
Debug.ShouldStop(8);
anywheresoftware.b4a.keywords.Common.Log("DirInternalCache = "+anywheresoftware.b4a.keywords.Common.File.getDirInternalCache());
 BA.debugLineNum = 69;BA.debugLine="Log(\"DirDefaultExternal = \" & File.DirDefaultExternal)";
Debug.ShouldStop(16);
anywheresoftware.b4a.keywords.Common.Log("DirDefaultExternal = "+anywheresoftware.b4a.keywords.Common.File.getDirDefaultExternal());
 BA.debugLineNum = 70;BA.debugLine="Log(\"DirRootExternal = \" & File.DirRootExternal)";
Debug.ShouldStop(32);
anywheresoftware.b4a.keywords.Common.Log("DirRootExternal = "+anywheresoftware.b4a.keywords.Common.File.getDirRootExternal());
 BA.debugLineNum = 72;BA.debugLine="TestDir1 = File.DirRootExternal";
Debug.ShouldStop(128);
_testdir1 = anywheresoftware.b4a.keywords.Common.File.getDirRootExternal();Debug.locals.put("TestDir1", _testdir1);
 BA.debugLineNum = 73;BA.debugLine="Log(\" \")";
Debug.ShouldStop(256);
anywheresoftware.b4a.keywords.Common.Log(" ");
 BA.debugLineNum = 75;BA.debugLine="Log(\"Test dir path:  '/mnt/extSdCard/Android'.\")";
Debug.ShouldStop(1024);
anywheresoftware.b4a.keywords.Common.Log("Test dir path:  '/mnt/extSdCard/Android'.");
 BA.debugLineNum = 76;BA.debugLine="Rslt = File.IsDirectory(\"/mnt/extSdCard\", \"Android\")";
Debug.ShouldStop(2048);
_rslt = anywheresoftware.b4a.keywords.Common.File.IsDirectory("/mnt/extSdCard","Android");Debug.locals.put("Rslt", _rslt);
 BA.debugLineNum = 77;BA.debugLine="If Rslt = True Then";
Debug.ShouldStop(4096);
if (_rslt==anywheresoftware.b4a.keywords.Common.True) { 
 BA.debugLineNum = 78;BA.debugLine="Log(\"Directory 'Android' found on External SD Card.\")";
Debug.ShouldStop(8192);
anywheresoftware.b4a.keywords.Common.Log("Directory 'Android' found on External SD Card.");
 BA.debugLineNum = 79;BA.debugLine="TestDir2 = \"/mnt/extSdCard/Android\"";
Debug.ShouldStop(16384);
_testdir2 = "/mnt/extSdCard/Android";Debug.locals.put("TestDir2", _testdir2);
 }else {
 BA.debugLineNum = 81;BA.debugLine="Log(\"Directory 'Android' NOT found on External SD Card.\")";
Debug.ShouldStop(65536);
anywheresoftware.b4a.keywords.Common.Log("Directory 'Android' NOT found on External SD Card.");
 BA.debugLineNum = 82;BA.debugLine="Log(\"New Test dir path:   '/storage/extSdCard/Android'.\")";
Debug.ShouldStop(131072);
anywheresoftware.b4a.keywords.Common.Log("New Test dir path:   '/storage/extSdCard/Android'.");
 BA.debugLineNum = 83;BA.debugLine="Rslt = File.IsDirectory(\"/storage/extSdCard\", \"Android\")";
Debug.ShouldStop(262144);
_rslt = anywheresoftware.b4a.keywords.Common.File.IsDirectory("/storage/extSdCard","Android");Debug.locals.put("Rslt", _rslt);
 BA.debugLineNum = 84;BA.debugLine="If Rslt = True Then";
Debug.ShouldStop(524288);
if (_rslt==anywheresoftware.b4a.keywords.Common.True) { 
 BA.debugLineNum = 85;BA.debugLine="Log(\"Directory 'Android' found on External SD Card.\")";
Debug.ShouldStop(1048576);
anywheresoftware.b4a.keywords.Common.Log("Directory 'Android' found on External SD Card.");
 BA.debugLineNum = 86;BA.debugLine="TestDir2 = \"/storage/extSdCardAndroid\"";
Debug.ShouldStop(2097152);
_testdir2 = "/storage/extSdCardAndroid";Debug.locals.put("TestDir2", _testdir2);
 }else {
 BA.debugLineNum = 88;BA.debugLine="Log(\"Directory 'Android' NOT found on External SD Card.\")";
Debug.ShouldStop(8388608);
anywheresoftware.b4a.keywords.Common.Log("Directory 'Android' NOT found on External SD Card.");
 BA.debugLineNum = 89;BA.debugLine="Log(\"New Test dir path:   '/mnt/sdcard/Android'.\")";
Debug.ShouldStop(16777216);
anywheresoftware.b4a.keywords.Common.Log("New Test dir path:   '/mnt/sdcard/Android'.");
 BA.debugLineNum = 90;BA.debugLine="Rslt = File.IsDirectory(\"/mnt/sdcard\", \"Android\")";
Debug.ShouldStop(33554432);
_rslt = anywheresoftware.b4a.keywords.Common.File.IsDirectory("/mnt/sdcard","Android");Debug.locals.put("Rslt", _rslt);
 BA.debugLineNum = 91;BA.debugLine="If Rslt = True Then";
Debug.ShouldStop(67108864);
if (_rslt==anywheresoftware.b4a.keywords.Common.True) { 
 BA.debugLineNum = 92;BA.debugLine="Log(\"Directory 'Android' found on External SD Card.\")";
Debug.ShouldStop(134217728);
anywheresoftware.b4a.keywords.Common.Log("Directory 'Android' found on External SD Card.");
 BA.debugLineNum = 93;BA.debugLine="TestDir2 = \"/mnt/sdcard/Android\"";
Debug.ShouldStop(268435456);
_testdir2 = "/mnt/sdcard/Android";Debug.locals.put("TestDir2", _testdir2);
 }else {
 BA.debugLineNum = 95;BA.debugLine="Log(\"Directory 'Android' NOT found on External SD Card.\")";
Debug.ShouldStop(1073741824);
anywheresoftware.b4a.keywords.Common.Log("Directory 'Android' NOT found on External SD Card.");
 BA.debugLineNum = 96;BA.debugLine="Log(\"New Test dir path:   '/storage/sdcard/Android'.\")";
Debug.ShouldStop(-2147483648);
anywheresoftware.b4a.keywords.Common.Log("New Test dir path:   '/storage/sdcard/Android'.");
 BA.debugLineNum = 97;BA.debugLine="Rslt = File.IsDirectory(\"/storage/sdcard\", \"Android\")";
Debug.ShouldStop(1);
_rslt = anywheresoftware.b4a.keywords.Common.File.IsDirectory("/storage/sdcard","Android");Debug.locals.put("Rslt", _rslt);
 BA.debugLineNum = 98;BA.debugLine="If Rslt = True Then";
Debug.ShouldStop(2);
if (_rslt==anywheresoftware.b4a.keywords.Common.True) { 
 BA.debugLineNum = 99;BA.debugLine="Log(\"Directory 'Android' found on External SD Card.\")";
Debug.ShouldStop(4);
anywheresoftware.b4a.keywords.Common.Log("Directory 'Android' found on External SD Card.");
 BA.debugLineNum = 100;BA.debugLine="TestDir2 = \"/storage/sdcard/Android\"";
Debug.ShouldStop(8);
_testdir2 = "/storage/sdcard/Android";Debug.locals.put("TestDir2", _testdir2);
 }else {
 BA.debugLineNum = 103;BA.debugLine="Log(\"Directory 'Android' NOT found on External SD Card.\")";
Debug.ShouldStop(64);
anywheresoftware.b4a.keywords.Common.Log("Directory 'Android' NOT found on External SD Card.");
 BA.debugLineNum = 104;BA.debugLine="Log(\"All options have been tried.  External SD card is a) not present, b) is locked or c) is not available on this device.\")";
Debug.ShouldStop(128);
anywheresoftware.b4a.keywords.Common.Log("All options have been tried.  External SD card is a) not present, b) is locked or c) is not available on this device.");
 BA.debugLineNum = 105;BA.debugLine="Msgbox(\"External SD Card cannot be found.  It is either not present, locked or a different name is used than that in this app.  If the latter appears to be the problem, please notify the publisher.  Otherwise, please insert an SD card and try starting the app again.  Because this app requires an external SD card supplied and inserted by you, the user, without such a card the app cannot continue and will close when you tap the OK button.  Thank you.\", \"SD Card Not Found\")";
Debug.ShouldStop(256);
anywheresoftware.b4a.keywords.Common.Msgbox("External SD Card cannot be found.  It is either not present, locked or a different name is used than that in this app.  If the latter appears to be the problem, please notify the publisher.  Otherwise, please insert an SD card and try starting the app again.  Because this app requires an external SD card supplied and inserted by you, the user, without such a card the app cannot continue and will close when you tap the OK button.  Thank you.","SD Card Not Found",mostCurrent.activityBA);
 BA.debugLineNum = 106;BA.debugLine="Activity.Finish";
Debug.ShouldStop(512);
mostCurrent._activity.Finish();
 };
 };
 };
 };
 BA.debugLineNum = 117;BA.debugLine="T1 = TestDir1";
Debug.ShouldStop(1048576);
_t1 = _testdir1;Debug.locals.put("T1", _t1);
 BA.debugLineNum = 118;BA.debugLine="T1 = T1 & \"/Android\"";
Debug.ShouldStop(2097152);
_t1 = _t1+"/Android";Debug.locals.put("T1", _t1);
 BA.debugLineNum = 119;BA.debugLine="Log(\"T1 = \" & T1)";
Debug.ShouldStop(4194304);
anywheresoftware.b4a.keywords.Common.Log("T1 = "+_t1);
 BA.debugLineNum = 120;BA.debugLine="Log(\"TestDir2 = \" & TestDir2)";
Debug.ShouldStop(8388608);
anywheresoftware.b4a.keywords.Common.Log("TestDir2 = "+_testdir2);
 BA.debugLineNum = 121;BA.debugLine="If (TestDir2.Length > 0) AND (TestDir2 <> T1) Then";
Debug.ShouldStop(16777216);
if ((_testdir2.length()>0) && ((_testdir2).equals(_t1) == false)) { 
 BA.debugLineNum = 122;BA.debugLine="StartDir = TestDir2 'Use the StartDir to process the string.";
Debug.ShouldStop(33554432);
_startdir = _testdir2;Debug.locals.put("StartDir", _startdir);
 BA.debugLineNum = 123;BA.debugLine="Log(\"StartDir = \" & StartDir)";
Debug.ShouldStop(67108864);
anywheresoftware.b4a.keywords.Common.Log("StartDir = "+_startdir);
 BA.debugLineNum = 124;BA.debugLine="Log(\" \")";
Debug.ShouldStop(134217728);
anywheresoftware.b4a.keywords.Common.Log(" ");
 BA.debugLineNum = 125;BA.debugLine="TempRoot = \"\"";
Debug.ShouldStop(268435456);
_temproot = "";Debug.locals.put("TempRoot", _temproot);
 BA.debugLineNum = 126;BA.debugLine="For I = 0 To StartDir.Length - 1";
Debug.ShouldStop(536870912);
{
final double step81 = 1;
final double limit81 = (int)(_startdir.length()-1);
for (_i = (int)(0); (step81 > 0 && _i <= limit81) || (step81 < 0 && _i >= limit81); _i += step81) {
Debug.locals.put("I", _i);
 BA.debugLineNum = 129;BA.debugLine="If StartDir.CharAt(I) = \"/\" Then";
Debug.ShouldStop(1);
if (_startdir.charAt(_i)==BA.ObjectToChar("/")) { 
 BA.debugLineNum = 131;BA.debugLine="SlashCnt = SlashCnt + 1";
Debug.ShouldStop(4);
_slashcnt = (int)(_slashcnt+1);Debug.locals.put("SlashCnt", _slashcnt);
 BA.debugLineNum = 133;BA.debugLine="If SlashCnt = 3 Then";
Debug.ShouldStop(16);
if (_slashcnt==3) { 
 BA.debugLineNum = 135;BA.debugLine="Exit";
Debug.ShouldStop(64);
if (true) break;
 };
 };
 BA.debugLineNum = 139;BA.debugLine="SB.Append(StartDir.CharAt(I))";
Debug.ShouldStop(1024);
_sb.Append(String.valueOf(_startdir.charAt(_i)));
 BA.debugLineNum = 140;BA.debugLine="Log(\" I = \" & I & \"; Current char = \" & StartDir.CharAt(I) & \"; SB = \" & SB)";
Debug.ShouldStop(2048);
anywheresoftware.b4a.keywords.Common.Log(" I = "+BA.NumberToString(_i)+"; Current char = "+String.valueOf(_startdir.charAt(_i))+"; SB = "+String.valueOf(_sb));
 }
}Debug.locals.put("I", _i);
;
 BA.debugLineNum = 142;BA.debugLine="TempRoot = SB.ToString";
Debug.ShouldStop(8192);
_temproot = _sb.ToString();Debug.locals.put("TempRoot", _temproot);
 BA.debugLineNum = 143;BA.debugLine="Log(\" \")";
Debug.ShouldStop(16384);
anywheresoftware.b4a.keywords.Common.Log(" ");
 BA.debugLineNum = 144;BA.debugLine="Log(\"TempRoot = \" & TempRoot)";
Debug.ShouldStop(32768);
anywheresoftware.b4a.keywords.Common.Log("TempRoot = "+_temproot);
 }else {
 BA.debugLineNum = 147;BA.debugLine="TempRoot = TestDir1";
Debug.ShouldStop(262144);
_temproot = _testdir1;Debug.locals.put("TempRoot", _temproot);
 BA.debugLineNum = 148;BA.debugLine="Log(\"TempRoot = TestDir1 and is:  \" & TempRoot)";
Debug.ShouldStop(524288);
anywheresoftware.b4a.keywords.Common.Log("TempRoot = TestDir1 and is:  "+_temproot);
 };
 BA.debugLineNum = 150;BA.debugLine="Log(\" \")";
Debug.ShouldStop(2097152);
anywheresoftware.b4a.keywords.Common.Log(" ");
 BA.debugLineNum = 151;BA.debugLine="Return TempRoot";
Debug.ShouldStop(4194304);
if (true) return _temproot;
 BA.debugLineNum = 152;BA.debugLine="End Sub";
Debug.ShouldStop(8388608);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 38055, new int[] {5}, "def1e937-2561-465f-83be-dd85c5de27f2");}

    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
    
            if (main.previousOne != null) {
				Activity a = main.previousOne.get();
				if (a != null)
					a.finish();
			}

}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 21;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 24;BA.debugLine="Dim ExtRoot As String 'The obtained root directory for the actual physical external SD card (user supplied).";
mostCurrent._extroot = "";
 //BA.debugLineNum = 25;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 19;BA.debugLine="End Sub";
return "";
}
  public Object[] GetGlobals() {
		return new Object[] {"Activity",_activity,"ExtRoot",_extroot};
}
}
